;1) LoadCommonControls
;   This function has no parameters, it is just needed to load the Comctl32.dll
;   library and the rebarwindow32 control
;
;2) CreateReBarControl(
;    HWND (DWORD): Handle of the parent window 
;    WIDTH (DWORD): Width of the Rebar control 
;    HEIGHT (DWORD): Height of the Rebar control 
;    VERTICAL (DWORD): TRUE/FALSE, sets the Rebar control in a vertical state
;    HINSTANCE (DWORD): handle to application instance
;    )
;  This function returns the handle of the Rebar control but it isn't needed
;  because already stored by the Dll
;
;3) CreateReBarBand(
;    HWND (DWORD): Handle of the control you want to insert in the rebar band
;                  ex: combo boxes, toolbars, etc... *
;    HWND (DWORD): Handle of the bitmap you want to place in back ground *
;    LPCTSTR (DWORD): Pointer to a text *
;    BRKLINE (DWORD): TRUE/FALSE, sets the brake line
;    MOVABLE (DWORD): TRUE/FALSE, sets if the band is moveable or not
;    )
;
;* if you don't want to use this options just set them to NULL

		DlgItem2Rebar macro p1,p2

		__ GetDlgItem,hWin,p1
		__ CreateReBarBand,eax,0,p2,0,0
		endm

.data
ReBarClassName db "ReBarWindow32",0
BlankText dd 0
WhWnd dd 0
MsgCaption db "Error",0
MsgText db "An error has occurred, unable to create the rebar",0
MsgText1 db "ReBar control has not been created",0
MsgText2 db "Unable to create a rebar band",0
ToolBarClassName db "ToolbarWindow32",0
ReBarHwnd dd 0
ControlClassName db 15 dup(?),0
.const
		
.code
LoadCommonControls proc
LOCAL CcEx:INITCOMMONCONTROLSEX
		mov CcEx.dwSize, SIZEOF INITCOMMONCONTROLSEX
		mov CcEx.dwICC, ICC_COOL_CLASSES
		Invoke InitCommonControlsEx, addr CcEx
		ret
LoadCommonControls endp
		hInst textequ <hInstance>
CreateReBarControl proc hWnd:HWND, WidthR:DWORD, HeightR:DWORD, VerticalR:DWORD
LOCAL ReBarStyle:DWORD
		
		push hWnd
		pop WhWnd
		.if VerticalR==FALSE
			Invoke CreateWindowEx, NULL, addr ReBarClassName, NULL, WS_CHILD Or \
			WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or WS_VISIBLE Or RBS_VARHEIGHT Or RBS_BANDBORDERS Or WS_BORDER\
			, 0, 0, WidthR, HeightR, WhWnd, NULL, hInst, NULL
			.ELSE
			Invoke CreateWindowEx, NULL, addr ReBarClassName, NULL, WS_CHILD Or CCS_VERT Or \
			WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or WS_VISIBLE Or RBS_VARHEIGHT Or RBS_BANDBORDERS Or WS_BORDER\
			, 0, 0, WidthR, HeightR, WhWnd, NULL, hInst, NULL
		.endif
		mov ReBarHwnd, eax
		.if ReBarHwnd==NULL
			Invoke MessageBoxEx, hWnd, addr MsgText, addr MsgCaption, \
			MB_OK or MB_ICONEXCLAMATION, NULL
			jmp EndProc
		.endif
		Invoke ShowWindow,eax,SW_SHOWNORMAL
		EndProc:
		ret
CreateReBarControl endp
CreateReBarBand proc CtrHwnd:HWND, BmpHwnd:HWND, TextPointer:DWORD, BrkLine:DWORD, Moveable:DWORD
LOCAL RbBInfo:REBARBANDINFO
LOCAL Rct:RECT
		
		.if ReBarHwnd==NULL
			Invoke MessageBoxEx, WhWnd, addr MsgText1, addr MsgCaption, \
			MB_OK or MB_ICONEXCLAMATION, NULL
		.endif
		mov RbBInfo.cbSize, SIZEOF REBARBANDINFO
		mov RbBInfo.fMask, RBBIM_STYLE Or RBBIM_ID Or RBBIM_COLORS Or RBBIM_SIZE 
		mov RbBInfo.fStyle, RBBS_FIXEDBMP or RBBS_CHILDEDGE
		Invoke GetSysColor, COLOR_BTNFACE
		mov RbBInfo.clrBack, eax
		Invoke GetSysColor, COLOR_BTNTEXT
		mov RbBInfo.clrFore, eax
		cmp CtrHwnd, NULL ;If There's no Control Handle skip all this instructions
		je fine1
		mov RbBInfo.fMask, RBBIM_CHILD Or RBBIM_CHILDSIZE
		push CtrHwnd
		pop RbBInfo.hwndChild
		Invoke GetClassName, CtrHwnd, addr ControlClassName, 300
		Invoke lstrcmp, addr ControlClassName, addr ToolBarClassName ; check if the control is a Toolbar
		.if eax==0 ; if so set make it flat
			Invoke SetWindowLong, CtrHwnd, GWL_STYLE, 1442875725
		.endif
		Invoke GetWindowRect, CtrHwnd, addr Rct
		add Rct.bottom,2
		mov eax, DWORD PTR [Rct.right]
		mov ebx, DWORD PTR [Rct.left]
		Sub eax, ebx
		mov RbBInfo.cxMinChild, eax
		mov eax, DWORD PTR [Rct.bottom]
		mov ebx, DWORD PTR [Rct.top]
		sub eax, ebx
		mov RbBInfo.cyMinChild, eax
		fine1:
		
		cmp BmpHwnd, NULL ;if there's no bitmap handle Skip
		je fine2
		Or RbBInfo.fMask, RBBIM_BACKGROUND
		push BmpHwnd
		pop eax
		mov RbBInfo.hbmBack, eax
		fine2:
		
		mov eax, DWORD PTR [TextPointer] ; if there's no ReBar Title skip
		cmp eax, NULL
		je fine3
		Or RbBInfo.fMask, RBBIM_TEXT 
		mov RbBInfo.lpText, eax
		Invoke lstrlen, eax 
		mov RbBInfo.cch, eax
		fine3:
		
		.if Moveable==FALSE
			or RbBInfo.fStyle, RBBS_FIXEDSIZE
		.elseif Moveable==TRUE
			mov eax, RBBS_FIXEDSIZE
			Not eax
			And RbBInfo.fStyle,eax
		.endif
		.if BrkLine==TRUE
			Or RbBInfo.fStyle, RBBS_BREAK
		.endif
		Invoke SendMessage, ReBarHwnd, RB_GETBANDCOUNT, NULL, NULL
		add eax,1
		mov RbBInfo.wID, eax
		mov RbBInfo.lx, 200
		Invoke SendMessage, ReBarHwnd, RB_INSERTBAND, -1,addr RbBInfo
		.if eax==0
			Invoke MessageBoxEx, WhWnd, addr MsgText2, addr MsgCaption, \
			MB_OK or MB_ICONEXCLAMATION, NULL
		.endif
		ret
CreateReBarBand endp 
